#include <windows.h>
#include <string>
#include <stdio.h>
#include <string.h>

using namespace std;

class DateTime
{
private:
    int nYear;
    int nMonth;
    int nDay;
    int nHour;
    int nMinute;
    int nSecond;

private:
    bool isLeapYear(int nYear);
    int DaysOfMonth(int nMonth);
    int DaysOfMonth(int nMonth, int nYear);

public :
    DateTime(int nInitYear=0, int nInitMonth=1, int nInitDay=1, int nInitHour=0, int nInitMinute=0, int nInitSecond=0);
    DateTime(char *szDateTime){ fromString(szDateTime); }
    DateTime(DateTime &dOther) {operator =(dOther);}
    virtual ~DateTime(){;}
    //197011
    operator double();
    //ַʽ
    operator string();
    //fDays
    DateTime operator +(double fDays);
    DateTime operator +(int    nDays){return operator +((double)nDays);}
    //fDaysǰ
    DateTime operator -(double fDays);
    DateTime operator -(int    nDays){return operator -((double)nDays);}
    //ڼľ룬λΪ
    double operator -(DateTime dOtherDate);
    //ַDateTimeֵ
    DateTime operator =(char *szDateTime);
    //һDateTimeDateTimeֵ
    DateTime &operator =(DateTime &dOther);
    //Լ
    DateTime operator ++();
    DateTime operator ++(int);
    //Լ
    DateTime operator --();
    DateTime operator --(int);

    DateTime operator +=(double fDays);
    DateTime operator +=(int    nDays){return operator +=((double)nDays);}
    DateTime operator -=(double fDays);
    DateTime operator -=(int    nDays){return operator -=((double)nDays);}

    //Ƚ
    bool operator >(DateTime dOther);
    bool operator <(DateTime dOther);
    bool operator >=(DateTime dOther);
    bool operator <=(DateTime dOther);
    bool operator ==(DateTime dOther);
    bool operator !=(DateTime dOther);

    //
    int getYear(){return nYear;}
    //
    int setYear(int nNewYear);
    //·
    int getMonth(){return nMonth;}
    //·
    int setMonth(int nNewMonth);
    //
    int getDay(){return nDay;}
    //
    int setDay(int nNewDay);
    //Сʱ
    int getHour(){return nHour;}
    //Сʱ
    int setHour(int nNewHour);
    //÷
    int getMinute(){return nMinute;}
    //÷
    int setMinute(int nNewMinute);
    //
    int getSecond(){return nSecond;}
    //
    int setSecond(int nNewSecond);

    //ʱתΪַ
    string toString() {return operator string();}
    //ַתΪDateTime
    DateTime fromString(char *szDateTime);
    //ĳһڼοչʽ
    int getWeekday();
    //ַ
    string getDate();
    //ʱַ
    string getTime();
};

bool DateTime::isLeapYear(int nYear)
{
    return (nYear%400==0)||(nYear%100!=0&&nYear%4==0);
}

int DateTime::DaysOfMonth(int nMonth)
{
    if(nMonth<0||nMonth>12)return 0;
    int Days[13]={31,31,28,31,30,31,30,31,31,30,31,30,31};
    if((nYear%400==0)||(nYear%100!=0&&nYear%4==0))Days[2]++;
    return Days[nMonth];
}

int DateTime::DaysOfMonth(int nMonth, int nYear)
{
    static int Days[13]={31,31,28,31,30,31,30,31,31,30,31,30,31};
    if(nMonth<0||nMonth>12)return 0;

    if(((nYear%400==0)||(nYear%100!=0&&nYear%4==0))&&nMonth==2)
        return Days[2]+1;
    else
        return Days[nMonth];
}

DateTime::DateTime(int nInitYear, int nInitMonth, int nInitDay, int nInitHour, int nInitMinute, int nInitSecond)
{
    if (nInitYear==0)
    {
        SYSTEMTIME ssDateTime;
        GetLocalTime(&ssDateTime);
        nYear=ssDateTime.wYear;
        nMonth=ssDateTime.wMonth;
        nDay=ssDateTime.wDay;
        nHour=ssDateTime.wHour;
        nMinute=ssDateTime.wMinute;
        nSecond=ssDateTime.wSecond;
    }
    else
    {
        nYear=nInitYear;
        if (nInitMonth<1) nMonth=1;
            else if (nInitMonth>12) nMonth=12;
                else nMonth=nInitMonth;
        if (nInitDay<1) nDay=1;
            else if (nInitDay>DaysOfMonth(nMonth)) nDay=DaysOfMonth(nMonth);
                else nDay=nInitDay;
        if (nInitHour<0) nHour=0;
            else if (nInitHour>23) nHour=23;
                else nHour=nInitHour;
        if (nInitMinute<0) nMinute=0;
            else if (nInitMinute>59) nMinute=59;
                else nMinute=nInitMinute;
        if (nInitSecond<0) nSecond=0;
            else if (nInitSecond>59) nSecond=59;
                else nSecond=nInitSecond;
    }
}

DateTime::operator double()
{
    int i;
    double fCount;
    fCount=0;
    for(i=1970; i<nYear; i++)
    {
        if ((i%400==0)||(i%100!=0&&i%4==0))
            fCount+=366;
        else
            fCount+=365;
    }

    for(i=1; i<nMonth; i++)
        fCount+=DaysOfMonth(i);

    fCount+=nDay;
    fCount+=(double)nHour/24;
    fCount+=(double)nMinute/60;
    fCount+=(double)nSecond/60;

    return fCount;
}

DateTime::operator string()
{
    string sTemp;
    sTemp.resize(50);
    sprintf((char *)sTemp.c_str(), "%i-%i-%i %02i:%02i:%02i", nYear, nMonth, nDay, nHour, nMinute, nSecond);
    return sTemp;
}

DateTime DateTime::operator +(double fDays)
{
    if(fDays<0)return operator -(-fDays);
    DateTime dTemp=*this;

    double fMinor=fDays-(int)fDays;
    int    nDays=(int)fDays;

    int nHr  =(fMinor*=24);
    fMinor-=nHr;
    int nMin =(fMinor*=60);
    fMinor-=nMin;
    int nSec =(fMinor*=60)+0.5;

    dTemp.nSecond+=nSec;
    if(dTemp.nSecond>59)
    {
        dTemp.nSecond-=60;
        dTemp.nMinute++;
    }

    dTemp.nMinute+=nMin;
    if(dTemp.nMinute>59)
    {
        dTemp.nMinute-=60;
        dTemp.nHour++;
    }

    dTemp.nHour+=nHr;
    if(dTemp.nHour>23)
    {
        dTemp.nHour-=24;
        dTemp++;
    }

    for(int i=0; i<nDays; i++)
        dTemp++;

    return dTemp;
}

DateTime DateTime::operator -(double fDays)
{
    if(fDays<0)return operator -(-fDays);
    DateTime dTemp=*this;

    double fMinor=(int)fDays-fDays;
    int    nDays=(int)fDays;

    int nHr  =(fMinor*=24);
    fMinor-=nHr;
    int nMin =(fMinor*=60);
    fMinor-=nMin;
    int nSec =(fMinor*=60)-0.5;

    dTemp.nSecond+=nSec;
    if(dTemp.nSecond<0)
    {
        dTemp.nSecond+=60;
        dTemp.nMinute--;
    }

    dTemp.nMinute+=nMin;
    if(dTemp.nMinute<0)
    {
        dTemp.nMinute+=60;
        dTemp.nHour--;
    }

    dTemp.nHour+=nHr;
    if(dTemp.nHour<0)
    {
        dTemp.nHour+=24;
        dTemp--;
    }

    for(int i=0; i<nDays; i++)
        dTemp--;

    return dTemp;
}

double DateTime::operator -(DateTime dOtherDate)
{
    if(dOtherDate>*this)return -(dOtherDate-(*this));
    DateTime dTemp=*this;
    DateTime dTemp1;
    double fTemp=0;
    int i;
    bool flag=false;
    double nTemp=0;
    if (dTemp<dOtherDate)
    {
        flag=true;
        dTemp1=dTemp;
        dTemp=dOtherDate;
        dOtherDate=dTemp1;
    }
    if (dTemp.nSecond>dOtherDate.nSecond) nTemp+=(double)(dTemp.nSecond-dOtherDate.nSecond)/24/60/60;
    if (dTemp.nSecond<dOtherDate.nSecond)
    {
        nTemp+=(double)(dTemp.nSecond-dOtherDate.nSecond+60)/24/60/60;
        dTemp.nMinute--;
        if (dTemp.nMinute<0) {dTemp.nHour--; dTemp.nMinute+=60; }
        if (dTemp.nHour<0) {dTemp.nDay--; dTemp.nHour+=24; }
        if (dTemp.nDay<1) {dTemp.nMonth--; dTemp.nDay+=DaysOfMonth(dTemp.nMonth,dTemp.nYear); }
        if (dTemp.nMonth<1) {dTemp.nYear--; dTemp.nMonth+=12; }
    }
    dTemp.nSecond=dOtherDate.nSecond;

    if (dTemp.nMinute>dOtherDate.nMinute) nTemp+=(double)(dTemp.nMinute-dOtherDate.nMinute)/24/60;
    if (dTemp.nMinute<dOtherDate.nMinute)
    {
        nTemp+=(double)(dTemp.nMinute-dOtherDate.nMinute+60)/24/60;
        dTemp.nHour--;
        if (dTemp.nHour<0) {dTemp.nDay--; dTemp.nHour+=24; }
        if (dTemp.nDay<1) {dTemp.nMonth--; dTemp.nDay+=DaysOfMonth(dTemp.nMonth,dTemp.nYear); }
        if (dTemp.nMonth<1) {dTemp.nYear--; dTemp.nMonth+=12; }
    }
    dTemp.nMinute=dOtherDate.nMinute;

    if (dTemp.nHour>dOtherDate.nHour) nTemp+=(double)(dTemp.nHour-dOtherDate.nHour)/24;
    if (dTemp.nHour<dOtherDate.nHour)
    {
        nTemp+=(double)(dTemp.nHour-dOtherDate.nHour+24)/24;
        dTemp.nDay--;
        if (dTemp.nDay<1) {dTemp.nMonth--; dTemp.nDay+=DaysOfMonth(dTemp.nMonth,dTemp.nYear); }
        if (dTemp.nMonth<1) {dTemp.nYear--; dTemp.nMonth+=12; }
    }
    dTemp.nHour=dOtherDate.nHour;

    if (dTemp.nDay>dOtherDate.nDay) nTemp+=dTemp.nDay-dOtherDate.nDay;
    if (dTemp.nDay<dOtherDate.nDay)
    {
        nTemp+=dTemp.nDay-dOtherDate.nDay+DaysOfMonth(dTemp.nMonth-1,dTemp.nYear);
        dTemp.nMonth--;
        if (dTemp.nMonth<1) {dTemp.nYear--; dTemp.nMonth+=12; }
    }
    dTemp.nDay=dOtherDate.nDay;

    if (dTemp.nMonth>dOtherDate.nMonth)
        for(i=dTemp.nMonth; i>dOtherDate.nMonth; i--) nTemp+=DaysOfMonth(i-1,dTemp.nYear);
    if (dTemp.nMonth<dOtherDate.nMonth)
    {
        for(i=dTemp.nMonth; i<dOtherDate.nMonth; i++) nTemp-=DaysOfMonth(i,dTemp.nYear);
        dTemp.nYear--;
        if (dTemp.nMonth>2)
        {
            if (DaysOfMonth(2,dTemp.nYear+1)==29) nTemp+=366;
                else nTemp+=365;
        }
        if (dTemp.nMonth<=2)
        {
            if (DaysOfMonth(2,dTemp.nYear)==29)nTemp+=366;
                else nTemp+=365;
        }
    }
    dTemp.nMonth=dOtherDate.nMonth;

    if (dTemp.nYear>dOtherDate.nYear)
        for(i=dTemp.nYear; i>dOtherDate.nYear; i--)
            if((dTemp.nMonth>2&&DaysOfMonth(2,i)==29)||(dTemp.nMonth<=2&&DaysOfMonth(2,i-1)==29)) nTemp+=366;
                else nTemp+=365;
    if (flag) nTemp=-nTemp;
    return nTemp;
}

DateTime &DateTime::operator =(DateTime &dOther)
{
    nYear   = dOther.nYear;
    nMonth  = dOther.nMonth;
    nDay    = dOther.nDay;
    nHour   = dOther.nHour;
    nMinute = dOther.nMinute;
    nSecond = dOther.nSecond;

    return *this;
}

bool DateTime::operator !=(DateTime dOther)
{
    if(nYear==dOther.nYear) return false;
    if(nMonth==dOther.nMonth) return false;
    if(nDay==dOther.nDay) return false;
    if(nHour==dOther.nHour) return false;
    if(nMinute==dOther.nMinute) return false;
    if(nSecond==dOther.nSecond) return false;
    return true;
}

bool DateTime::operator ==(DateTime dOther)
{
    if(nYear  != dOther.nYear)  return false;
    if(nMonth != dOther.nMonth) return false;
    if(nDay   != dOther.nDay)   return false;
    if(nHour  != dOther.nHour)  return false;
    if(nMinute!=dOther.nMinute) return false;
    if(nSecond!=dOther.nSecond) return false;
    return true;
}

bool DateTime::operator <(DateTime dOther)
{
    if(nYear<dOther.nYear) return true;
    if(nYear>dOther.nYear) return false;
    if(nMonth<dOther.nMonth) return true;
    if(nMonth>dOther.nMonth) return false;
    if(nDay<dOther.nDay) return true;
    if(nDay>dOther.nDay) return false;
    if(nHour<dOther.nHour) return true;
    if(nHour>dOther.nHour) return false;
    if(nMinute<dOther.nMinute) return true;
    if(nMinute>dOther.nMinute) return false;
    if(nSecond<dOther.nSecond) return true;
    if(nSecond>dOther.nSecond) return false;
    return false;
}

bool DateTime::operator >(DateTime dOther)
{
    if(nYear>dOther.nYear) return true;
    if(nYear<dOther.nYear) return false;
    if(nMonth>dOther.nMonth) return true;
    if(nMonth<dOther.nMonth) return false;
    if(nDay>dOther.nDay) return true;
    if(nDay<dOther.nDay) return false;
    if(nHour>dOther.nHour) return true;
    if(nHour<dOther.nHour) return false;
    if(nMinute>dOther.nMinute) return true;
    if(nMinute<dOther.nMinute) return false;
    if(nSecond>dOther.nSecond) return true;
    if(nSecond<dOther.nSecond) return false;
    return false;
}

bool DateTime::operator <=(DateTime dOther)
{
    return operator <(dOther)||operator ==(dOther);
}

bool DateTime::operator >=(DateTime dOther)
{
    return operator >(dOther)||operator ==(dOther);
}

int DateTime::setYear(int nNewYear)
{
    return nYear=nNewYear;
}

int DateTime::setMonth(int nNewMonth)
{
    if (nNewMonth<1)
        return nMonth=1;

    if(nNewMonth>12)
        return nMonth=12;

    return nMonth=nNewMonth;;
}

int DateTime::setDay(int nNewDay)
{
    if (nNewDay<1)
        return nDay=1;

    if(nNewDay>DaysOfMonth(nMonth))
        return nDay=DaysOfMonth(nMonth);

    return nDay=nNewDay;
}

int DateTime::setHour(int nNewHour)
{
    if (nNewHour<0)
        return nHour=0;

    if(nNewHour>23)
        return nHour=23;

    return nHour=nNewHour;
}

int DateTime::setMinute(int nNewMinute)
{
    if (nNewMinute<0)
        return nMinute=0;

    if(nNewMinute>59)
        return nMinute=59;

    return nMinute=nNewMinute;
}

int DateTime::setSecond(int nNewSecond)
{
    if (nNewSecond<0)
        return nSecond=0;

    if(nNewSecond>59)
        return nSecond=59;

    return nSecond=nNewSecond;
}

DateTime DateTime::fromString(char *szDateTime)
{
    int i,j;
    char pos;
    bool flag=false;
    DateTime dTemp;
    string szTemp;
    SYSTEMTIME ssDateTime;
    GetLocalTime(&ssDateTime);
    szTemp="";
    for(i=0; szDateTime[i]==' '; i++) ;
    for(; szDateTime[i]>='0'&&szDateTime[i]<='9'; i++)
        szTemp+=szDateTime[i];
    pos=szDateTime[i];
    if (szTemp!="") {dTemp.nYear=atoi(szTemp.data()); i++; }
    szTemp="";
    for(; szDateTime[i]>='0'&&szDateTime[i]<='9'; i++)
        szTemp+=szDateTime[i];
    if (szTemp!="") {dTemp.nMonth=atoi(szTemp.c_str()); i++;}
    szTemp="";
    for(; szDateTime[i]>='0'&&szDateTime[i]<='9'; i++)
        szTemp+=szDateTime[i];
    if (szTemp!="") {dTemp.nDay=atoi(szTemp.c_str()); }
        else dTemp.nDay=0;
    dTemp.nHour=0;
    dTemp.nMinute=0;
    dTemp.nSecond=0;
    if (pos=='/')
    {
        j=dTemp.nDay;
        if (j==0) j=ssDateTime.wYear;
        dTemp.nDay=dTemp.nMonth;
        dTemp.nMonth=dTemp.nYear;
        dTemp.nYear=j;
    }
    if (pos==':')
    {
        dTemp.nHour=dTemp.nYear;
        dTemp.nMinute=dTemp.nMonth;
        dTemp.nSecond=dTemp.nDay;
        dTemp.nYear=ssDateTime.wYear;
        dTemp.nMonth=ssDateTime.wMonth;
        dTemp.nDay=ssDateTime.wDay;
        flag=true;
    }
    if (pos!='/'&&pos!=':'&&pos!='-')
    {
        dTemp.nYear=ssDateTime.wYear;
        dTemp.nMonth=ssDateTime.wMonth;
        dTemp.nDay=ssDateTime.wDay;
        dTemp.nMinute=ssDateTime.wMinute;
        dTemp.nHour=ssDateTime.wHour;
        dTemp.nSecond=ssDateTime.wSecond;
        *this=dTemp;
        return dTemp;
    }
    if (dTemp.nYear<1) dTemp.nYear=1;
    if (dTemp.nYear<70) dTemp.nYear+=2000;
    if ((dTemp.nYear>=70)&&(dTemp.nYear<100)) dTemp.nYear+=1900;
    if (dTemp.nMonth<1) dTemp.nMonth=1;
    if (dTemp.nMonth>12) dTemp.nMonth=12;
    if (dTemp.nDay<1) dTemp.nDay=1;
    if (dTemp.nDay>DaysOfMonth(dTemp.nMonth,dTemp.nYear)) dTemp.nDay=DaysOfMonth(dTemp.nMonth,dTemp.nYear);
    szTemp="";
    for(; szDateTime[i]==' '; i++) ;
    for(; szDateTime[i]>='0'&&szDateTime[i]<='9'; i++)
        szTemp+=szDateTime[i];
    if (szTemp!="") { dTemp.nHour=atoi(szTemp.c_str()); i++; flag=true; }
    szTemp="";
    for(; szDateTime[i]>='0'&&szDateTime[i]<='9'; i++)
        szTemp+=szDateTime[i];
    if (szTemp!="") { dTemp.nMinute=atoi(szTemp.c_str()); i++; }
    if (dTemp.nMinute<0) dTemp.nMinute=0;
    if (dTemp.nMinute>59) dTemp.nMinute=59;
    szTemp="";
    for(; szDateTime[i]>='0'&&szDateTime[i]<='9'; i++)
        szTemp+=szDateTime[i];
    if (szTemp!="") dTemp.nSecond=atoi(szTemp.c_str());
    if (dTemp.nSecond<0) dTemp.nSecond=0;
    if (dTemp.nSecond>59) dTemp.nSecond=59;
    for(; szDateTime[i]==' '; i++) ;
    if ((szDateTime[i]=='P'||szDateTime[i]=='p')&&flag) dTemp.nHour+=12;
    if (dTemp.nHour<0) dTemp.nHour=0;
    if (dTemp.nHour>23) dTemp.nHour=23;
    *this=dTemp;
    return dTemp;
}

string DateTime::getDate()
{
    string sTemp;
    sTemp.resize(50);
    sprintf((char *)sTemp.c_str(),"%i-%i-%i",nYear,nMonth,nDay);
    return sTemp;
}

string DateTime::getTime()
{
    string sTemp;
    sTemp.resize(50);
    sprintf((char *)sTemp.c_str(),"%2i:%02i:%02i",nHour,nMinute,nDay);
    return sTemp;
}

DateTime DateTime::operator ++()
{
    nDay++;
    if(nDay>DaysOfMonth(nMonth))
    {
        nDay=1;
        nMonth++;

        if(nMonth>12)
        {
            nMonth=1;
            nYear++;
        }
    }

    return *this;
}

DateTime DateTime::operator ++(int)
{
    DateTime temp=*this;
    operator ++();
    return temp;
}
DateTime DateTime::operator --()
{
    nDay--;
    if(nDay<1)
    {
        nMonth--;
        if(nMonth<1)
        {
            nMonth=12;
            nYear--;
        }

        nDay=DaysOfMonth(nMonth);
    }

    return *this;
}

DateTime DateTime::operator --(int)
{
    DateTime temp=*this;
    operator --();
    return temp;
}

int DateTime::getWeekday()
{
    int dTemp=(int)(*this-"1980-1-6 00:00:00");
    return (dTemp%7);
}

DateTime DateTime::operator +=(double fDays)
{
    return operator =(operator +(fDays));
}

DateTime DateTime::operator -=(double fDays)
{
    return operator =(operator -(fDays));
}

DateTime Now()
{
    return DateTime("");
}
