#include <vector>
#include "DateTime.h"

class Variant
{
    friend Variant &Null();
private :
    string szData;
    string szType;
public :
    Variant(){szType="Null"; szData="";}
    Variant(char *szInit);
    Variant(double bInit);
    Variant(DateTime dInit);
    //Ƚ
    bool operator >(string szString);
    bool operator <(string szString);
    bool operator >=(string szString){return !operator <(szString);}
    bool operator <=(string szString){return !operator >(szString);}
    bool operator ==(string szString);
    bool operator !=(string szString){return !operator ==(szString);}
    //ת
    operator double(){return toNumber();}
    operator DateTime(){return toDateTime();}
    operator string(){return toString();}
    //ֵ
    Variant operator =(double fNumber){return fromNumber(fNumber);}
    Variant operator =(string szString){return fromString(szString);}
    Variant operator =(DateTime dDateTime){return fromDateTime(dDateTime);}
    //תΪַʧܵ
    string toString() {return szData;}
    //ֵַ
    Variant fromString(string szString) {szType="String"; szData=szString; return *this;}
    //תΪʧܣתΪ0
    double toNumber();
    //ֵָ
    Variant fromNumber(double fNumber);
    //תΪʱ䣬ʧܣתΪ190011
    DateTime toDateTime();
    //ʱ丳ֵ
    Variant fromDateTime(DateTime dDateTime);
    //ǷΪ
    bool isNull(){return szType=="Null";}
};

Variant::Variant(char *szInit)
{
    szData=szInit;
    szType="string";
}

Variant::Variant(double bInit)
{
    szData.resize(1000);
    sprintf((char*)szData.c_str(),"%g",bInit);
    szType="double";
}

Variant::Variant(DateTime dInit)
{
    szData=(string)dInit;
    szType="String";
}

double Variant::toNumber()
{
    double fTemp;
    fTemp=atof(szData.c_str());
    if (szType=="Number")
        return fTemp;
    else
        return 0;
}

Variant Variant::fromNumber(double fNumber)
{
    szData.resize(1000);
    sprintf((char*)szData.c_str(), "%g", fNumber);
    szType="Number";
    return *this;
}

DateTime Variant::toDateTime()
{
    DateTime dTemp;
    dTemp.fromString((char*)szData.c_str());
    return dTemp;
}

Variant Variant::fromDateTime(DateTime dDateTime)
{
    szData=(string)dDateTime;
    szType="DateTime";
    return *this;
}

bool Variant::operator >(string szString)
{
    if(szType=="Number")
    {
        if(szString.size())
            return toNumber()>atof((char *)szString.c_str());
        else
            return toNumber()>0;
    }
    else if(szType=="String")
        return szData>szString;
    else if(szType=="DateTime")
        return toDateTime()>DateTime((char *)szString.c_str());

    return false;
}

bool Variant::operator <(string szString)
{
    if(szType=="Number")
    {
        if(szString.size())
            return toNumber()<atof((char *)szString.c_str());
        else
            return toNumber()<0;
    }
    else if(szType=="String")
        return szData<szString;
    else if(szType=="DateTime")
        return toDateTime()<DateTime((char *)szString.c_str());

    return false;
}

bool Variant::operator ==(string szString)
{
    if(szType=="Number")
    {
        if(szString.size())
            return toNumber()==atof((char *)szString.c_str());
        else
            return toNumber()==0;
    }
    else if(szType=="String")
        return szData==szString;
    else if(szType=="DateTime")
        return toDateTime()==DateTime((char *)szString.c_str());

    return false;
}

Variant &Null()
{
    static Variant temp;
    temp.szData="";
    temp.szType="Null";
    return temp;
}
