// Stat.cpp : implementation file
//

#include "stdafx.h"
#include "TeleMan.h"
#include "Stat.h"

#include "XmlPd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Stat dialog


Stat::Stat(CWnd* pParent /*=NULL*/)
    : CDialog(Stat::IDD, pParent)
{
    //{{AFX_DATA_INIT(Stat)
        // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}


void Stat::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(Stat)
    DDX_Control(pDX, IDC_LIST, m_ListTime);
    DDX_Control(pDX, IDC_STATIC_CELL, m_PicCell);
    DDX_Control(pDX, IDC_STATIC_BAR, m_PicBar);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Stat, CDialog)
    //{{AFX_MSG_MAP(Stat)
    ON_WM_PAINT()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Stat message handlers

struct Income
{
    unsigned int nTime;
    double dFee;
};

BOOL Stat::OnInitDialog()
{
    CDialog::OnInitDialog();

    XmlDatabase myDb;
    myDb.LoadFromFile("Time.xdb");

    for(unsigned int i=0; i<24; i++)
        dFee[i]=0;

    for(i=0; i<myDb.size(); i++)
        dFee[myDb[i]["StartTime"].toDateTime().getHour()]+=myDb[i]["Cost"].toNumber();

    double dMax=0;
    for(i=0; i<24; i++)
    {
        if(dFee[i]>dMax)
            dMax=dFee[i];
    }

    CString buffer;
    Income myIncome[24];

    for(i=0; i<24; i++)
    {
        myIncome[i].nTime=i;
        myIncome[i].dFee=dFee[i];

        if(dMax)
            dFee[i]/=dMax;
        else
            dFee[i]=0;
    }

    for(i=0; i<23; i++)
    {
        int k=i;
        for(int j=i+1; j<24; j++)
        {
            if(myIncome[j].dFee<myIncome[k].dFee)
                k=j;
        }

        Income temp;
        temp=myIncome[k];
        myIncome[k]=myIncome[i];
        myIncome[i]=temp;
    }

    for(i=0; i<24; i++)
    {
        buffer.Format("%2i  %6.2f", myIncome[i].nTime, myIncome[i].dFee);
        m_ListTime.AddString(buffer);
    }
    // TODO: Add extra initialization here
    return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX Property Pages should return FALSE
}

void Stat::OnPaint()
{
    CPaintDC dc(this); // device context for painting

    RECT myRect, lRect, wRect, dRect;

    m_PicBar.GetWindowRect(&myRect);
    m_ListTime.GetWindowRect(&lRect);
    GetWindowRect(&wRect);

    dRect.left=myRect.left-wRect.left;
    dRect.right=myRect.right-wRect.left;
    dRect.top=myRect.top-lRect.top;
    dRect.bottom=myRect.bottom-lRect.top;

    double dStep=(dRect.right-dRect.left)/24;

    for(unsigned int i=0; i<24; i++)
    {
        CBrush myBrush;
        if(i>=7&&i<21)
            myBrush.CreateSolidBrush(RGB(255, 255, 0));
        else if(i>=21&&i<24)
            myBrush.CreateSolidBrush(RGB(0, 128, 0));
        else
            myBrush.CreateSolidBrush(RGB(0, 0, 255));

        CBrush *oldBrush=dc.SelectObject(&myBrush);
        dc.Rectangle(dRect.left+i*dStep, dRect.bottom-dFee[i]*(dRect.bottom-dRect.top), dRect.left+(i+1)*dStep+1, dRect.bottom);
        dc.SelectObject(oldBrush);
    }

    m_PicCell.GetWindowRect(&myRect);
    m_ListTime.GetWindowRect(&lRect);
    GetWindowRect(&wRect);

    dRect.left=myRect.left-wRect.left;
    dRect.right=myRect.right-wRect.left;
    dRect.top=myRect.top-lRect.top;
    dRect.bottom=myRect.bottom-lRect.top;

    dc.Ellipse(dRect.left, dRect.top, dRect.right, dRect.bottom);

    double dPoint[3]={0, 0, 0};
    for(i=0; i<8; i++)
        dPoint[0]+=dFee[i];
    for(i=8; i<21; i++)
        dPoint[1]+=dFee[i];
    for(i=21; i<24; i++)
        dPoint[2]+=dFee[i];

    double dTotal=dPoint[0]+dPoint[1]+dPoint[2];

    if(dTotal==0)
        return;

    dPoint[0]=dPoint[0]/dTotal*2*3.14159265358979;
    dPoint[1]=dPoint[0]+dPoint[1]/dTotal*2*3.14159265358979;
    dPoint[2]=dPoint[1]+dPoint[2]/dTotal*2*3.14159265358979;

    int a=(dRect.right-dRect.left)/2;
    int b=(dRect.bottom-dRect.top)/2;
    int x=(dRect.left+dRect.right)/2;
    int y=(dRect.top+dRect.bottom)/2;

    POINT start, end;
    start.x=x+a;
    start.y=y;
    end.x=x+a*cos(dPoint[0]);
    end.y=y+b*sin(dPoint[0]);

    CBrush brush;
    brush.CreateSolidBrush(RGB(0, 0, 255));
    CBrush *oldBrush=dc.SelectObject(&brush);
    dc.Pie(&dRect, end, start);
    dc.SelectObject(oldBrush);

    for(i=0; i<2; i++)
    {
        start.x=x+a*cos(dPoint[i]);
        start.y=y+b*sin(dPoint[i]);
        end.x=x+a*cos(dPoint[i+1]);
        end.y=y+b*sin(dPoint[i+1]);

        CBrush myBrush;
        switch(i)
        {
        case 0:
            myBrush.CreateSolidBrush(RGB(255, 255, 0));
            break;
        case 1:
            myBrush.CreateSolidBrush(RGB(0, 128, 0));
            break;
        }

        CBrush *oldBrush=dc.SelectObject(&myBrush);
        dc.Pie(&dRect, end, start);
        dc.SelectObject(oldBrush);
    }
    // TODO: Add your message handler code here
    // Do not call CDialog::OnPaint() for painting messages
}
