// TeleManDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TeleMan.h"
#include "TeleManDlg.h"

#include "AccMan.h"
#include "EmuCall.h"
#include "Query.h"
#include "Stat.h"

#include "XmlPd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
    afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
    afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
    afx_msg void OnEmailSlugoo();
    afx_msg void OnEmailEdyfox();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
    ON_WM_DRAWITEM()
    ON_WM_SETCURSOR()
    ON_BN_CLICKED(IDC_EMAIL_SLUGOO, OnEmailSlugoo)
    ON_BN_CLICKED(IDC_EMAIL_EDYFOX, OnEmailEdyfox)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTeleManDlg dialog

CTeleManDlg::CTeleManDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CTeleManDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CTeleManDlg)
        // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTeleManDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CTeleManDlg)
    DDX_Control(pDX, IDC_LIST, m_List);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTeleManDlg, CDialog)
    //{{AFX_MSG_MAP(CTeleManDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_COMMAND(IDR_ACCMAN, OnAccman)
    ON_COMMAND(IDR_EMUCALL, OnEmucall)
    ON_COMMAND(IDR_QUERY, OnQuery)
    ON_COMMAND(IDR_STAT, OnStat)
    ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
    ON_COMMAND(IDM_INSTRUCTION, OnInstruction)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTeleManDlg message handlers

BOOL CTeleManDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    XmlDatabase MyDB;
    if(MyDB.LoadFromFile("Account.xdb")==false)
    {
        MyDB.AddColumn("Account", "String", "绰");
        MyDB.AddColumn("UserName", "String", "û");
        MyDB.AddColumn("Address", "String", "סַ");
        MyDB.SaveToFile();
    }

    if(MyDB.LoadFromFile("Time.xdb")==false)
    {
        MyDB.AddColumn("Account", "String", "绰");
        MyDB.AddColumn("ToNum", "String", "к");
        MyDB.AddColumn("StartTime", "DateTime", "ʼʱ");
        MyDB.AddColumn("EndTime", "DateTime", "ʱ");
        MyDB.AddColumn("Cost", "Number", "");
        MyDB.SaveToFile();
    }

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    HICON m_BigIcon;
    HICON m_SmallIcon;

    m_BigIcon  =(HICON)LoadImage(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
    m_SmallIcon=(HICON)LoadImage(AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

    SetIcon(m_BigIcon, TRUE);            // Set big icon
    SetIcon(m_SmallIcon, FALSE);        // Set small icon

    // TODO: Add extra initialization here
    Refresh();
    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTeleManDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTeleManDlg::OnPaint()
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTeleManDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CTeleManDlg::OnAccman()
{
    // TODO: Add your command handler code here
    AccMan dlg;
    dlg.DoModal();
}

void CTeleManDlg::Refresh()
{
    while(m_List.GetCount())
        m_List.DeleteString(0);

    XmlDatabase myDb;
    myDb.LoadFromFile("Time.xdb");

    for(unsigned int i=0; i<myDb.size(); i++)
    {
        string buffer;
        buffer.resize(1000);
        sprintf((char *)buffer.c_str(), "%19s  %19s %s  %s",
            myDb[i]["StartTime"].toString().c_str(),
            myDb[i]["EndTime"].toString().c_str(),
            myDb[i]["Account"].toString().c_str(),
            myDb[i]["ToNum"].toString().c_str());
        m_List.AddString(buffer.c_str());
    }
}

void CTeleManDlg::OnEmucall()
{
    // TODO: Add your command handler code here
    EmuCall dlg;
    dlg.DoModal();
    Refresh();
}

void CTeleManDlg::OnQuery()
{
    // TODO: Add your command handler code here
    Query dlg;
    dlg.DoModal();
}

void CTeleManDlg::OnStat()
{
    // TODO: Add your command handler code here
    Stat dlg;
    dlg.DoModal();
}

void CTeleManDlg::OnAboutbox()
{
    // TODO: Add your command handler code here
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
}

void CTeleManDlg::OnInstruction()
{
    // TODO: Add your command handler code here
    fstream myStream;
    myStream.open("Readme.htm", ios::in);
    if(myStream.good())
        ShellExecute(m_hWnd, "open", "Readme.htm", NULL, NULL, SW_SHOW);
    else
    {
        MessageBox("Ҳ˵飬ͳӦϵ", "绰Ʒѳ", MB_ICONINFORMATION);
        CAboutDlg dlg;
        dlg.DoModal();
    }
}

void CAboutDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
    // TODO: Add your message handler code here and/or call default
    // TODO: Add your message handler code here and/or call default
    COLORREF oldColor;

    switch(nIDCtl)
    {
    case IDC_EMAIL_SLUGOO:
        oldColor=SetTextColor(lpDrawItemStruct->hDC,RGB(0,0,255));
        TextOut(lpDrawItemStruct->hDC,0,0,"slugchen@sina.com",22);
        SetTextColor(lpDrawItemStruct->hDC,oldColor);
        break;
    case IDC_EMAIL_EDYFOX:
        oldColor=SetTextColor(lpDrawItemStruct->hDC,RGB(0,0,255));
        TextOut(lpDrawItemStruct->hDC,0,0,"edyfox@btamail.net.cn",21);
        SetTextColor(lpDrawItemStruct->hDC,oldColor);
        break;
    default:
        CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
    }
}

BOOL CAboutDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
    // TODO: Add your message handler code here and/or call default
    CWinApp *pApp=AfxGetApp();

    CRect rcBtn;
    CPoint ptCursor;
    CWnd *pBtn;

    GetCursorPos(&ptCursor);

    pBtn=GetDlgItem(IDC_EMAIL_SLUGOO);
    pBtn->GetWindowRect(rcBtn);

    if(rcBtn.PtInRect(ptCursor))
    {
        SetCursor(pApp->LoadCursor(IDC_CURSOR_HAND));
        return TRUE;
    }

    pBtn=GetDlgItem(IDC_EMAIL_EDYFOX);
    pBtn->GetWindowRect(rcBtn);

    if(rcBtn.PtInRect(ptCursor))
    {
        SetCursor(pApp->LoadCursor(IDC_CURSOR_HAND));
        return TRUE;
    }

    return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

void CAboutDlg::OnEmailSlugoo()
{
    // TODO: Add your control notification handler code here
    ShellExecute(m_hWnd,"open","mailto:slugchen@sina.com",NULL,NULL,SW_SHOW);
}

void CAboutDlg::OnEmailEdyfox()
{
    // TODO: Add your control notification handler code here
    ShellExecute(m_hWnd,"open","mailto:edyfox@btamail.net.cn",NULL,NULL,SW_SHOW);
}
