#ifndef _XmlDB_Appeared_
#define _XmlDB_Appeared_

#include <fstream>
#include <string>
#include <stdio.h>
#include <string.h>
#include <stack>
#include <stdlib.h>
#include <vector>
#include <windows.h>

using namespace std;

class DateTime
{
private:
    int nYear;
    int nMonth;
    int nDay;
    int nHour;
    int nMinute;
    int nSecond;

private:
    bool isLeapYear(int nYear);
    int DaysOfMonth(int nMonth);
    int DaysOfMonth(int nMonth, int nYear);

public :
    DateTime(int nInitYear=0, int nInitMonth=1, int nInitDay=1, int nInitHour=0, int nInitMinute=0, int nInitSecond=0);
    DateTime(char *szDateTime){ fromString(szDateTime); }
    DateTime(DateTime &dOther) {operator =(dOther);}
    virtual ~DateTime(){;}
    //197011
    operator double();
    //ַʽ
    operator string();
    //fDays
    DateTime operator +(double fDays);
    DateTime operator +(int    nDays){return operator +((double)nDays);}
    //fDaysǰ
    DateTime operator -(double fDays);
    DateTime operator -(int    nDays){return operator -((double)nDays);}
    //ڼľ룬λΪ
    double operator -(DateTime dOtherDate);
    //ַDateTimeֵ
    DateTime operator =(char *szDateTime);
    //һDateTimeDateTimeֵ
    DateTime &operator =(DateTime &dOther);
    //Լ
    DateTime operator ++();
    DateTime operator ++(int);
    //Լ
    DateTime operator --();
    DateTime operator --(int);

    DateTime operator +=(double fDays);
    DateTime operator +=(int    nDays){return operator +=((double)nDays);}
    DateTime operator -=(double fDays);
    DateTime operator -=(int    nDays){return operator -=((double)nDays);}

    //Ƚ
    bool operator >(DateTime dOther);
    bool operator <(DateTime dOther);
    bool operator >=(DateTime dOther);
    bool operator <=(DateTime dOther);
    bool operator ==(DateTime dOther);
    bool operator !=(DateTime dOther);

    //
    int getYear(){return nYear;}
    //
    int setYear(int nNewYear);
    //·
    int getMonth(){return nMonth;}
    //·
    int setMonth(int nNewMonth);
    //
    int getDay(){return nDay;}
    //
    int setDay(int nNewDay);
    //Сʱ
    int getHour(){return nHour;}
    //Сʱ
    int setHour(int nNewHour);
    //÷
    int getMinute(){return nMinute;}
    //÷
    int setMinute(int nNewMinute);
    //
    int getSecond(){return nSecond;}
    //
    int setSecond(int nNewSecond);

    //ʱתΪַ
    string toString() {return operator string();}
    //ַתΪDateTime
    DateTime fromString(char *szDateTime);
    //ĳһڼοչʽ
    int getWeekday();
    //ַ
    string getDate();
    //ʱַ
    string getTime();
};

class Variant
{
    friend Variant &Null();
private :
    string szData;
    string szType;
public :
    Variant(){szType="Null"; szData="";}
    Variant(char *szInit);
    Variant(double bInit);
    Variant(DateTime dInit);
    //Ƚ
    bool operator >(string szString);
    bool operator <(string szString);
    bool operator >=(string szString){return !operator <(szString);}
    bool operator <=(string szString){return !operator >(szString);}
    bool operator ==(string szString);
    bool operator !=(string szString){return !operator ==(szString);}
    //ת
    operator double(){return toNumber();}
    operator DateTime(){return toDateTime();}
    operator string(){return toString();}
    //ֵ
    Variant operator =(double fNumber){return fromNumber(fNumber);}
    Variant operator =(string szString){return fromString(szString);}
    Variant operator =(DateTime dDateTime){return fromDateTime(dDateTime);}
    //תΪַʧܵ
    string toString() {return szData;}
    //ֵַ
    Variant fromString(string szString) {szType="String"; szData=szString; return *this;}
    //תΪʧܣתΪ0
    double toNumber();
    //ֵָ
    Variant fromNumber(double fNumber);
    //תΪʱ䣬ʧܣתΪ190011
    DateTime toDateTime();
    //ʱ丳ֵ
    Variant fromDateTime(DateTime dDateTime);
    //ǷΪ
    bool isNull(){return szType=="Null";}
};
using namespace std;

struct Column
{
    string szColumnName;
    string szDataType;
    string szDescription;
};

class Record
{
    friend class XmlDatabase;
private:
    vector<Column> *pvColumns;
    vector<Variant> vRecord;
public:
    Variant &operator [](char *szColumnName);
    Variant &operator ()(char *szColumnName) {return operator[](szColumnName);}
};

class RecordSet
{
private:
    vector<Record*> vpRecord;
public:
    //صnԪصá
    Record operator[](unsigned int nIndex){return *vpRecord[nIndex];}
    //ؼ¼еԪظ
    int GetCount() {return vpRecord.size(); }
    void push(Record* vRecord) { vpRecord.push_back(vRecord);}
    void sort(char* szOrderby, bool byIncrease);
};

class XmlDatabase
{
protected:
    vector<Column> vColumns;
    vector<Record> vRecords;
    string szFilename;
    bool bAutoSave;

protected:
    //ʽһЩڲú

    bool Compare(char a, char b);
    bool count(bool a, char cOper, bool b);
    bool Boolean(char *szStatement);
    char Judge(char *szStatement, unsigned int nIndex);

    //ʽ
    bool Condition(char *szCondition, unsigned int nIndex);

public:
    XmlDatabase(char *szFileName=NULL){bAutoSave=false;LoadFromFile(szFileName);}
    virtual ~XmlDatabase(){if(bAutoSave)SaveToFile();}

    //ȡԪظ
    unsigned int size(){return vRecords.size();}
    //ֶ
    bool AddColumn(char *szColumn, char *szType, char *szDescription);
    //ɾֶ
    bool DeleteColumn(char *szColumn);
    //ɾֶ
    bool DeleteColumn(unsigned int nIndex);
    //صnIndexԪصãֱӶ
    Record &operator[](unsigned int nIndex){return vRecords[nIndex];}
    //ݣ
    bool Insert(char *szColumns, char *szData);
    //޸ݣ
    bool Update(char *szColumns, char *szData, char *szCondition);
    //ɾݣ
    bool Delete(char *szCondition);
    //ɾݣ
    bool Delete(unsigned int nIndex);
    //ɸѡݣ
    RecordSet Filter(char *szCondition, char *szOrderby, bool bIncrease=true);
    //ȫ
    bool Sort(char *szColumn, bool bIncrease=true);

    //д
    bool UpdateData(bool bSaveToFile=false){if(bSaveToFile)return SaveToFile();else return LoadFromFile();};
    //Ӵ̶ȡ
    bool LoadFromFile(char *szFileName=NULL);
    //д̡
    bool SaveToFile(char *szFileName=NULL);
};

string Replace(char *szText, char *szChange, char *szTo);
vector<string> Split(char *szText, char *szSplit);
string ltrim(char *szText);
string rtrim(char *szText);
string trim(char *szText);
string HtmlEncode(char *szText);
string HtmlDecode(char *szText);
DateTime Now();
Variant &Null();

#endif
